# Author : GuanFu Duan
# Email : gfduan178@163.com
# Supervisor : Changge Ji
# All rights reserved 2019
# polar bond define and the receptor charge with amber99SB
# Dependencies : opemmm, pdbfixer, openbabel, pybel

class Paras_info(object):

    def __init__(self, temp_illustration):
        # in order to record the paras information
        self.temp_illustration = temp_illustration

    def ligand_data(self):
        with open('ligand.database', 'w') as small:
            small.write(';%40s\n;  atom1  atom2       k             d\n;%40s\n' %(('='*40), ('='*40)))
            small.write('   C.1    N.1     3.11000       1.16000  \n')
            small.write('   C.ar    F      4.72000       1.36000  \n')
            small.write('   C.3     F      5.63000       1.33000  \n')
            small.write('   C.2     Cl     1.43000       1.82000  \n')
            small.write('   S.3     Cl     1.38000       2.12000  \n')
            small.write('   S.o2    Cl     1.36000       2.11000  \n')
            small.write('   C.ar    Cl     1.38000       1.72000  \n')
            small.write('   C.3     Cl     1.78000       1.78000  \n')
            small.write('   C.2     Br     1.18000       1.99000  \n')
            small.write('   S.3     Br     1.09000       2.36000  \n')
            small.write('   S.o2    Br     1.06000       2.37000  \n')
            small.write('   C.ar    Br     1.00000       1.90000  \n')
            small.write('   C.3     Br     1.33000       1.99000  \n')
            small.write('   C.2    O.2     3.51000       1.23000  \n')
            small.write('   C.2   O.co2    3.76000       1.25000  \n')
            small.write('   C.2    S.2     1.17000       1.66000  \n')
            small.write('   C.2     H      4.14000       1.09000  \n')
            small.write('   N.2    O.2     3.49000       1.21000  \n')
            small.write('   N.2     H      6.82000       1.01000  \n')
            small.write('   N.4     H     10.05000       1.01000  \n')
            small.write('   N.3     H      6.74000       1.01000  \n')
            small.write('   N.am    H      8.83000       1.01000  \n')
            small.write('  N.pl3    H      8.59000       1.01000  \n')
            small.write('  N.pl3  O.co2    3.80000       1.22000  \n')
            small.write('   O.3     H     10.97000       0.95000  \n')
            small.write('   S.3     H      3.29000       1.34000  \n')
            small.write('   S.3    O.2     2.44000       1.53000  \n')
            small.write('   S.o2   O.2     3.07000       1.47000  \n')
            small.write('   P.3   O.co2    3.92000       1.47000  \n')
            small.write(';%40s\n' %('='*40))
        with open(self.temp_illustration, 'a') as tmp_info:
            tmp_info.write('# The parameters of polar bond in small molecule.\n\t%s\n' %'ligand.database')

    def mmff94_charge(self):
        with open('mmff94.dat', 'w') as charge_file:
            charge_file.write(';%39s\n;  RESIDUE     ATOM    AMBER94.CHARGE\n;%39s\n' %(('='*39), ('-'*39)))
            charge_file.write('    ALA         N        -0.415700\n    ALA         H         0.271900\n')
            charge_file.write('    ALA         CA        0.033700\n    ALA         HA        0.082300\n')
            charge_file.write('    ALA         CB       -0.182500\n    ALA        HB1        0.060300\n')
            charge_file.write('    ALA        HB2        0.060300\n    ALA        HB3        0.060300\n')
            charge_file.write('    ALA         C         0.597300\n    ALA         O        -0.567900\n')
            charge_file.write('    ARG         N        -0.347900\n    ARG         H         0.274700\n')
            charge_file.write('    ARG         CA       -0.263700\n    ARG         HA        0.156000\n')
            charge_file.write('    ARG         CB       -0.000700\n    ARG        HB2        0.032700\n')
            charge_file.write('    ARG        HB3        0.032700\n    ARG         CG        0.039000\n')
            charge_file.write('    ARG        HG2        0.028500\n    ARG        HG3        0.028500\n')
            charge_file.write('    ARG         CD        0.048600\n    ARG        HD2        0.068700\n')
            charge_file.write('    ARG        HD3        0.068700\n    ARG         NE       -0.529500\n')
            charge_file.write('    ARG         HE        0.345600\n    ARG         CZ        0.807600\n')
            charge_file.write('    ARG        NH1       -0.862700\n    ARG        HH11       0.447800\n')
            charge_file.write('    ARG        HH12       0.447800\n    ARG        NH2       -0.862700\n')
            charge_file.write('    ARG        HH21       0.447800\n    ARG        HH22       0.447800\n')
            charge_file.write('    ARG         C         0.734100\n    ARG         O        -0.589400\n')
            charge_file.write('    ASH         N        -0.415700\n    ASH         H         0.271900\n')
            charge_file.write('    ASH         CA        0.034100\n    ASH         HA        0.086400\n')
            charge_file.write('    ASH         CB       -0.031600\n    ASH        HB2        0.048800\n')
            charge_file.write('    ASH        HB3        0.048800\n    ASH         CG        0.646200\n')
            charge_file.write('    ASH        OD1       -0.555400\n    ASH        OD2       -0.637600\n')
            charge_file.write('    ASH        HD2        0.474700\n    ASH         C         0.597300\n')
            charge_file.write('    ASH         O        -0.567900\n    ASN         N        -0.415700\n')
            charge_file.write('    ASN         H         0.271900\n    ASN         CA        0.014300\n')
            charge_file.write('    ASN         HA        0.104800\n    ASN         CB       -0.204100\n')
            charge_file.write('    ASN        HB2        0.079700\n    ASN        HB3        0.079700\n')
            charge_file.write('    ASN         CG        0.713000\n    ASN        OD1       -0.593100\n')
            charge_file.write('    ASN        ND2       -0.919100\n    ASN        HD21       0.419600\n')
            charge_file.write('    ASN        HD22       0.419600\n    ASN         C         0.597300\n')
            charge_file.write('    ASN         O        -0.567900\n    ASP         N        -0.516300\n')
            charge_file.write('    ASP         H         0.293600\n    ASP         CA        0.038100\n')
            charge_file.write('    ASP         HA        0.088000\n    ASP         CB       -0.030300\n')
            charge_file.write('    ASP        HB2       -0.012200\n    ASP        HB3       -0.012200\n')
            charge_file.write('    ASP         CG        0.799400\n    ASP        OD1       -0.801400\n')
            charge_file.write('    ASP        OD2       -0.801400\n    ASP         C         0.536600\n')
            charge_file.write('    ASP         O        -0.581900\n    CYM         N        -0.415700\n')
            charge_file.write('    CYM         H         0.271900\n    CYM         CA       -0.035100\n')
            charge_file.write('    CYM         HA        0.050800\n    CYM         CB       -0.241300\n')
            charge_file.write('    CYM        HB3        0.112200\n    CYM        HB2        0.112200\n')
            charge_file.write('    CYM         SG       -0.884400\n    CYM         C         0.597300\n')
            charge_file.write('    CYM         O        -0.567900\n    CYS         N        -0.415700\n')
            charge_file.write('    CYS         H         0.271900\n    CYS         CA        0.021300\n')
            charge_file.write('    CYS         HA        0.112400\n    CYS         CB       -0.123100\n')
            charge_file.write('    CYS        HB2        0.111200\n    CYS        HB3        0.111200\n')
            charge_file.write('    CYS         SG       -0.311900\n    CYS         HG        0.193300\n')
            charge_file.write('    CYS         C         0.597300\n    CYS         O        -0.567900\n')
            charge_file.write('    CYX         N        -0.415700\n    CYX         H         0.271900\n')
            charge_file.write('    CYX         CA        0.042900\n    CYX         HA        0.076600\n')
            charge_file.write('    CYX         CB       -0.079000\n    CYX        HB2        0.091000\n')
            charge_file.write('    CYX        HB3        0.091000\n    CYX         SG       -0.108100\n')
            charge_file.write('    CYX         C         0.597300\n    CYX         O        -0.567900\n')
            charge_file.write('    GLH         N        -0.415700\n    GLH         H         0.271900\n')
            charge_file.write('    GLH         CA        0.014500\n    GLH         HA        0.077900\n')
            charge_file.write('    GLH         CB       -0.007100\n    GLH        HB2        0.025600\n')
            charge_file.write('    GLH        HB3        0.025600\n    GLH         CG       -0.017400\n')
            charge_file.write('    GLH        HG2        0.043000\n    GLH        HG3        0.043000\n')
            charge_file.write('    GLH         CD        0.680100\n    GLH        OE1       -0.583800\n')
            charge_file.write('    GLH        OE2       -0.651100\n    GLH        HE2        0.464100\n')
            charge_file.write('    GLH         C         0.597300\n    GLH         O        -0.567900\n')
            charge_file.write('    GLN         N        -0.415700\n    GLN         H         0.271900\n')
            charge_file.write('    GLN         CA       -0.003100\n    GLN         HA        0.085000\n')
            charge_file.write('    GLN         CB       -0.003600\n    GLN        HB2        0.017100\n')
            charge_file.write('    GLN        HB3        0.017100\n    GLN         CG       -0.064500\n')
            charge_file.write('    GLN        HG2        0.035200\n    GLN        HG3        0.035200\n')
            charge_file.write('    GLN         CD        0.695100\n    GLN        OE1       -0.608600\n')
            charge_file.write('    GLN        NE2       -0.940700\n    GLN        HE21       0.425100\n')
            charge_file.write('    GLN        HE22       0.425100\n    GLN         C         0.597300\n')
            charge_file.write('    GLN         O        -0.567900\n    GLU         N        -0.516300\n')
            charge_file.write('    GLU         H         0.293600\n    GLU         CA        0.039700\n')
            charge_file.write('    GLU         HA        0.110500\n    GLU         CB        0.056000\n')
            charge_file.write('    GLU        HB2       -0.017300\n    GLU        HB3       -0.017300\n')
            charge_file.write('    GLU         CG        0.013600\n    GLU        HG2       -0.042500\n')
            charge_file.write('    GLU        HG3       -0.042500\n    GLU         CD        0.805400\n')
            charge_file.write('    GLU        OE1       -0.818800\n    GLU        OE2       -0.818800\n')
            charge_file.write('    GLU         C         0.536600\n    GLU         O        -0.581900\n')
            charge_file.write('    GLY         N        -0.415700\n    GLY         H         0.271900\n')
            charge_file.write('    GLY         CA       -0.025200\n    GLY        HA2        0.069800\n')
            charge_file.write('    GLY        HA3        0.069800\n    GLY         C         0.597300\n')
            charge_file.write('    GLY         O        -0.567900\n    HID         N        -0.415700\n')
            charge_file.write('    HID         H         0.271900\n    HID         CA        0.018800\n')
            charge_file.write('    HID         HA        0.088100\n    HID         CB       -0.046200\n')
            charge_file.write('    HID        HB2        0.040200\n    HID        HB3        0.040200\n')
            charge_file.write('    HID         CG       -0.026600\n    HID        ND1       -0.381100\n')
            charge_file.write('    HID        HD1        0.364900\n    HID        CE1        0.205700\n')
            charge_file.write('    HID        HE1        0.139200\n    HID        NE2       -0.572700\n')
            charge_file.write('    HID        CD2        0.129200\n    HID        HD2        0.114700\n')
            charge_file.write('    HID         C         0.597300\n    HID         O        -0.567900\n')
            charge_file.write('    HIE         N        -0.415700\n    HIE         H         0.271900\n')
            charge_file.write('    HIE         CA       -0.058100\n    HIE         HA        0.136000\n')
            charge_file.write('    HIE         CB       -0.007400\n    HIE        HB2        0.036700\n')
            charge_file.write('    HIE        HB3        0.036700\n    HIE         CG        0.186800\n')
            charge_file.write('    HIE        ND1       -0.543200\n    HIE        CE1        0.163500\n')
            charge_file.write('    HIE        HE1        0.143500\n    HIE        NE2       -0.279500\n')
            charge_file.write('    HIE        HE2        0.333900\n    HIE        CD2       -0.220700\n')
            charge_file.write('    HIE        HD2        0.186200\n    HIE         C         0.597300\n')
            charge_file.write('    HIE         O        -0.567900\n    HIP         N        -0.347900\n')
            charge_file.write('    HIP         H         0.274700\n    HIP         CA       -0.135400\n')
            charge_file.write('    HIP         HA        0.121200\n    HIP         CB       -0.041400\n')
            charge_file.write('    HIP        HB2        0.081000\n    HIP        HB3        0.081000\n')
            charge_file.write('    HIP         CG       -0.001200\n    HIP        ND1       -0.151300\n')
            charge_file.write('    HIP        HD1        0.386600\n    HIP        CE1       -0.017000\n')
            charge_file.write('    HIP        HE1        0.268100\n    HIP        NE2       -0.171800\n')
            charge_file.write('    HIP        HE2        0.391100\n    HIP        CD2       -0.114100\n')
            charge_file.write('    HIP        HD2        0.231700\n    HIP         C         0.734100\n')
            charge_file.write('    HIP         O        -0.589400\n    ILE         N        -0.415700\n')
            charge_file.write('    ILE         H         0.271900\n    ILE         CA       -0.059700\n')
            charge_file.write('    ILE         HA        0.086900\n    ILE         CB        0.130300\n')
            charge_file.write('    ILE         HB        0.018700\n    ILE        CG2       -0.320400\n')
            charge_file.write('    ILE        HG21       0.088200\n    ILE        HG22       0.088200\n')
            charge_file.write('    ILE        HG23       0.088200\n    ILE        CG1       -0.043000\n')
            charge_file.write('    ILE        HG12       0.023600\n    ILE        HG13       0.023600\n')
            charge_file.write('    ILE        CD1       -0.066000\n    ILE        HD11       0.018600\n')
            charge_file.write('    ILE        HD12       0.018600\n    ILE        HD13       0.018600\n')
            charge_file.write('    ILE         C         0.597300\n    ILE         O        -0.567900\n')
            charge_file.write('    LEU         N        -0.415700\n    LEU         H         0.271900\n')
            charge_file.write('    LEU         CA       -0.051800\n    LEU         HA        0.092200\n')
            charge_file.write('    LEU         CB       -0.110200\n    LEU        HB2        0.045700\n')
            charge_file.write('    LEU        HB3        0.045700\n    LEU         CG        0.353100\n')
            charge_file.write('    LEU         HG       -0.036100\n    LEU        CD1       -0.412100\n')
            charge_file.write('    LEU        HD11       0.100000\n    LEU        HD12       0.100000\n')
            charge_file.write('    LEU        HD13       0.100000\n    LEU        CD2       -0.412100\n')
            charge_file.write('    LEU        HD21       0.100000\n    LEU        HD22       0.100000\n')
            charge_file.write('    LEU        HD23       0.100000\n    LEU         C         0.597300\n')
            charge_file.write('    LEU         O        -0.567900\n    LYN         N        -0.415700\n')
            charge_file.write('    LYN         H         0.271900\n    LYN         CA       -0.072060\n')
            charge_file.write('    LYN         HA        0.099400\n    LYN         CB       -0.048450\n')
            charge_file.write('    LYN        HB2        0.034000\n    LYN        HB3        0.034000\n')
            charge_file.write('    LYN         CG        0.066120\n    LYN        HG2        0.010410\n')
            charge_file.write('    LYN        HG3        0.010410\n    LYN         CD       -0.037680\n')
            charge_file.write('    LYN        HD2        0.011550\n    LYN        HD3        0.011550\n')
            charge_file.write('    LYN         CE        0.326040\n    LYN        HE2       -0.033580\n')
            charge_file.write('    LYN        HE3       -0.033580\n    LYN         NZ       -1.035810\n')
            charge_file.write('    LYN        HZ2        0.386040\n    LYN        HZ3        0.386040\n')
            charge_file.write('    LYN         C         0.597300\n    LYN         O        -0.567900\n')
            charge_file.write('    LYS         N        -0.347900\n    LYS         H         0.274700\n')
            charge_file.write('    LYS         CA       -0.240000\n    LYS         HA        0.142600\n')
            charge_file.write('    LYS         CB       -0.009400\n    LYS        HB2        0.036200\n')
            charge_file.write('    LYS        HB3        0.036200\n    LYS         CG        0.018700\n')
            charge_file.write('    LYS        HG2        0.010300\n    LYS        HG3        0.010300\n')
            charge_file.write('    LYS         CD       -0.047900\n    LYS        HD2        0.062100\n')
            charge_file.write('    LYS        HD3        0.062100\n    LYS         CE       -0.014300\n')
            charge_file.write('    LYS        HE2        0.113500\n    LYS        HE3        0.113500\n')
            charge_file.write('    LYS         NZ       -0.385400\n    LYS        HZ1        0.340000\n')
            charge_file.write('    LYS        HZ2        0.340000\n    LYS        HZ3        0.340000\n')
            charge_file.write('    LYS         C         0.734100\n    LYS         O        -0.589400\n')
            charge_file.write('    MET         N        -0.415700\n    MET         H         0.271900\n')
            charge_file.write('    MET         CA       -0.023700\n    MET         HA        0.088000\n')
            charge_file.write('    MET         CB        0.034200\n    MET        HB2        0.024100\n')
            charge_file.write('    MET        HB3        0.024100\n    MET         CG        0.001800\n')
            charge_file.write('    MET        HG2        0.044000\n    MET        HG3        0.044000\n')
            charge_file.write('    MET         SD       -0.273700\n    MET         CE       -0.053600\n')
            charge_file.write('    MET        HE1        0.068400\n    MET        HE2        0.068400\n')
            charge_file.write('    MET        HE3        0.068400\n    MET         C         0.597300\n')
            charge_file.write('    MET         O        -0.567900\n    PHE         N        -0.415700\n')
            charge_file.write('    PHE         H         0.271900\n    PHE         CA       -0.002400\n')
            charge_file.write('    PHE         HA        0.097800\n    PHE         CB       -0.034300\n')
            charge_file.write('    PHE        HB2        0.029500\n    PHE        HB3        0.029500\n')
            charge_file.write('    PHE         CG        0.011800\n    PHE        CD1       -0.125600\n')
            charge_file.write('    PHE        HD1        0.133000\n    PHE        CE1       -0.170400\n')
            charge_file.write('    PHE        HE1        0.143000\n    PHE         CZ       -0.107200\n')
            charge_file.write('    PHE         HZ        0.129700\n    PHE        CE2       -0.170400\n')
            charge_file.write('    PHE        HE2        0.143000\n    PHE        CD2       -0.125600\n')
            charge_file.write('    PHE        HD2        0.133000\n    PHE         C         0.597300\n')
            charge_file.write('    PHE         O        -0.567900\n    PRO         N        -0.254800\n')
            charge_file.write('    PRO         CD        0.019200\n    PRO        HD2        0.039100\n')
            charge_file.write('    PRO        HD3        0.039100\n    PRO         CG        0.018900\n')
            charge_file.write('    PRO        HG2        0.021300\n    PRO        HG3        0.021300\n')
            charge_file.write('    PRO         CB       -0.007000\n    PRO        HB2        0.025300\n')
            charge_file.write('    PRO        HB3        0.025300\n    PRO         CA       -0.026600\n')
            charge_file.write('    PRO         HA        0.064100\n    PRO         C         0.589600\n')
            charge_file.write('    PRO         O        -0.574800\n    SER         N        -0.415700\n')
            charge_file.write('    SER         H         0.271900\n    SER         CA       -0.024900\n')
            charge_file.write('    SER         HA        0.084300\n    SER         CB        0.211700\n')
            charge_file.write('    SER        HB2        0.035200\n    SER        HB3        0.035200\n')
            charge_file.write('    SER         OG       -0.654600\n    SER         HG        0.427500\n')
            charge_file.write('    SER         C         0.597300\n    SER         O        -0.567900\n')
            charge_file.write('    THR         N        -0.415700\n    THR         H         0.271900\n')
            charge_file.write('    THR         CA       -0.038900\n    THR         HA        0.100700\n')
            charge_file.write('    THR         CB        0.365400\n    THR         HB        0.004300\n')
            charge_file.write('    THR        CG2       -0.243800\n    THR        HG21       0.064200\n')
            charge_file.write('    THR        HG22       0.064200\n    THR        HG23       0.064200\n')
            charge_file.write('    THR        OG1       -0.676100\n    THR        HG1        0.410200\n')
            charge_file.write('    THR         C         0.597300\n    THR         O        -0.567900\n')
            charge_file.write('    TRP         N        -0.415700\n    TRP         H         0.271900\n')
            charge_file.write('    TRP         CA       -0.027500\n    TRP         HA        0.112300\n')
            charge_file.write('    TRP         CB       -0.005000\n    TRP        HB2        0.033900\n')
            charge_file.write('    TRP        HB3        0.033900\n    TRP         CG       -0.141500\n')
            charge_file.write('    TRP        CD1       -0.163800\n    TRP        HD1        0.206200\n')
            charge_file.write('    TRP        NE1       -0.341800\n    TRP        HE1        0.341200\n')
            charge_file.write('    TRP        CE2        0.138000\n    TRP        CZ2       -0.260100\n')
            charge_file.write('    TRP        HZ2        0.157200\n    TRP        CH2       -0.113400\n')
            charge_file.write('    TRP        HH2        0.141700\n    TRP        CZ3       -0.197200\n')
            charge_file.write('    TRP        HZ3        0.144700\n    TRP        CE3       -0.238700\n')
            charge_file.write('    TRP        HE3        0.170000\n    TRP        CD2        0.124300\n')
            charge_file.write('    TRP         C         0.597300\n    TRP         O        -0.567900\n')
            charge_file.write('    TYR         N        -0.415700\n    TYR         H         0.271900\n')
            charge_file.write('    TYR         CA       -0.001400\n    TYR         HA        0.087600\n')
            charge_file.write('    TYR         CB       -0.015200\n    TYR        HB2        0.029500\n')
            charge_file.write('    TYR        HB3        0.029500\n    TYR         CG       -0.001100\n')
            charge_file.write('    TYR        CD1       -0.190600\n    TYR        HD1        0.169900\n')
            charge_file.write('    TYR        CE1       -0.234100\n    TYR        HE1        0.165600\n')
            charge_file.write('    TYR         CZ        0.322600\n    TYR         OH       -0.557900\n')
            charge_file.write('    TYR         HH        0.399200\n    TYR        CE2       -0.234100\n')
            charge_file.write('    TYR        HE2        0.165600\n    TYR        CD2       -0.190600\n')
            charge_file.write('    TYR        HD2        0.169900\n    TYR         C         0.597300\n')
            charge_file.write('    TYR         O        -0.567900\n    VAL         N        -0.415700\n')
            charge_file.write('    VAL         H         0.271900\n    VAL         CA       -0.087500\n')
            charge_file.write('    VAL         HA        0.096900\n    VAL         CB        0.298500\n')
            charge_file.write('    VAL         HB       -0.029700\n    VAL        CG1       -0.319200\n')
            charge_file.write('    VAL        HG11       0.079100\n    VAL        HG12       0.079100\n')
            charge_file.write('    VAL        HG13       0.079100\n    VAL        CG2       -0.319200\n')
            charge_file.write('    VAL        HG21       0.079100\n    VAL        HG22       0.079100\n')
            charge_file.write('    VAL        HG23       0.079100\n    VAL         C         0.597300\n')
            charge_file.write('    VAL         O        -0.567900\n    CALA        N        -0.382100\n')
            charge_file.write('    CALA        H         0.268100\n    CALA        CA       -0.174700\n')
            charge_file.write('    CALA        HA        0.106700\n    CALA        CB       -0.209300\n')
            charge_file.write('    CALA       HB1        0.076400\n    CALA       HB2        0.076400\n')
            charge_file.write('    CALA       HB3        0.076400\n    CALA        C         0.773100\n')
            charge_file.write('    CALA        O        -0.805500\n    CALA       OXT       -0.805500\n')
            charge_file.write('    CARG        N        -0.348100\n    CARG        H         0.276400\n')
            charge_file.write('    CARG        CA       -0.306800\n    CARG        HA        0.144700\n')
            charge_file.write('    CARG        CB       -0.037400\n    CARG       HB2        0.037100\n')
            charge_file.write('    CARG       HB3        0.037100\n    CARG        CG        0.074400\n')
            charge_file.write('    CARG       HG2        0.018500\n    CARG       HG3        0.018500\n')
            charge_file.write('    CARG        CD        0.111400\n    CARG       HD2        0.046800\n')
            charge_file.write('    CARG       HD3        0.046800\n    CARG        NE       -0.556400\n')
            charge_file.write('    CARG        HE        0.347900\n    CARG        CZ        0.836800\n')
            charge_file.write('    CARG       NH1       -0.873700\n    CARG       HH11       0.449300\n')
            charge_file.write('    CARG       HH12       0.449300\n    CARG       NH2       -0.873700\n')
            charge_file.write('    CARG       HH21       0.449300\n    CARG       HH22       0.449300\n')
            charge_file.write('    CARG        C         0.855700\n    CARG        O        -0.826600\n')
            charge_file.write('    CARG       OXT       -0.826600\n    CASN        N        -0.382100\n')
            charge_file.write('    CASN        H         0.268100\n    CASN        CA       -0.208000\n')
            charge_file.write('    CASN        HA        0.135800\n    CASN        CB       -0.229900\n')
            charge_file.write('    CASN       HB2        0.102300\n    CASN       HB3        0.102300\n')
            charge_file.write('    CASN        CG        0.715300\n    CASN       OD1       -0.601000\n')
            charge_file.write('    CASN       ND2       -0.908400\n    CASN       HD21       0.415000\n')
            charge_file.write('    CASN       HD22       0.415000\n    CASN        C         0.805000\n')
            charge_file.write('    CASN        O        -0.814700\n    CASN       OXT       -0.814700\n')
            charge_file.write('    CASP        N        -0.519200\n    CASP        H         0.305500\n')
            charge_file.write('    CASP        CA       -0.181700\n    CASP        HA        0.104600\n')
            charge_file.write('    CASP        CB       -0.067700\n    CASP       HB2       -0.021200\n')
            charge_file.write('    CASP       HB3       -0.021200\n    CASP        CG        0.885100\n')
            charge_file.write('    CASP       OD1       -0.816200\n    CASP       OD2       -0.816200\n')
            charge_file.write('    CASP        C         0.725600\n    CASP        O        -0.788700\n')
            charge_file.write('    CASP       OXT       -0.788700\n    CCYS        N        -0.382100\n')
            charge_file.write('    CCYS        H         0.268100\n    CCYS        CA       -0.163500\n')
            charge_file.write('    CCYS        HA        0.139600\n    CCYS        CB       -0.199600\n')
            charge_file.write('    CCYS       HB2        0.143700\n    CCYS       HB3        0.143700\n')
            charge_file.write('    CCYS        SG       -0.310200\n    CCYS        HG        0.206800\n')
            charge_file.write('    CCYS        C         0.749700\n    CCYS        O        -0.798100\n')
            charge_file.write('    CCYS       OXT       -0.798100\n    CCYX        N        -0.382100\n')
            charge_file.write('    CCYX        H         0.268100\n    CCYX        CA       -0.131800\n')
            charge_file.write('    CCYX        HA        0.093800\n    CCYX        CB       -0.194300\n')
            charge_file.write('    CCYX       HB2        0.122800\n    CCYX       HB3        0.122800\n')
            charge_file.write('    CCYX        SG       -0.052900\n    CCYX        C         0.761800\n')
            charge_file.write('    CCYX        O        -0.804100\n    CCYX       OXT       -0.804100\n')
            charge_file.write('    CGLN        N        -0.382100\n    CGLN        H         0.268100\n')
            charge_file.write('    CGLN        CA       -0.224800\n    CGLN        HA        0.123200\n')
            charge_file.write('    CGLN        CB       -0.066400\n    CGLN       HB2        0.045200\n')
            charge_file.write('    CGLN       HB3        0.045200\n    CGLN        CG       -0.021000\n')
            charge_file.write('    CGLN       HG2        0.020300\n    CGLN       HG3        0.020300\n')
            charge_file.write('    CGLN        CD        0.709300\n    CGLN       OE1       -0.609800\n')
            charge_file.write('    CGLN       NE2       -0.957400\n    CGLN       HE21       0.430400\n')
            charge_file.write('    CGLN       HE22       0.430400\n    CGLN        C         0.777500\n')
            charge_file.write('    CGLN        O        -0.804200\n    CGLN       OXT       -0.804200\n')
            charge_file.write('    CGLU        N        -0.519200\n    CGLU        H         0.305500\n')
            charge_file.write('    CGLU        CA       -0.205900\n    CGLU        HA        0.139900\n')
            charge_file.write('    CGLU        CB        0.007100\n    CGLU       HB2       -0.007800\n')
            charge_file.write('    CGLU       HB3       -0.007800\n    CGLU        CG        0.067500\n')
            charge_file.write('    CGLU       HG2       -0.054800\n    CGLU       HG3       -0.054800\n')
            charge_file.write('    CGLU        CD        0.818300\n    CGLU       OE1       -0.822000\n')
            charge_file.write('    CGLU       OE2       -0.822000\n    CGLU        C         0.742000\n')
            charge_file.write('    CGLU        O        -0.793000\n    CGLU       OXT       -0.793000\n')
            charge_file.write('    CGLY        N        -0.382100\n    CGLY        H         0.268100\n')
            charge_file.write('    CGLY        CA       -0.249300\n    CGLY       HA2        0.105600\n')
            charge_file.write('    CGLY       HA3        0.105600\n    CGLY        C         0.723100\n')
            charge_file.write('    CGLY        O        -0.785500\n    CGLY       OXT       -0.785500\n')
            charge_file.write('    CHID        N        -0.382100\n    CHID        H         0.268100\n')
            charge_file.write('    CHID        CA       -0.173900\n    CHID        HA        0.110000\n')
            charge_file.write('    CHID        CB       -0.104600\n    CHID       HB2        0.056500\n')
            charge_file.write('    CHID       HB3        0.056500\n    CHID        CG        0.029300\n')
            charge_file.write('    CHID       ND1       -0.389200\n    CHID       HD1        0.375500\n')
            charge_file.write('    CHID       CE1        0.192500\n    CHID       HE1        0.141800\n')
            charge_file.write('    CHID       NE2       -0.562900\n    CHID       CD2        0.100100\n')
            charge_file.write('    CHID       HD2        0.124100\n    CHID        C         0.761500\n')
            charge_file.write('    CHID        O        -0.801600\n    CHID       OXT       -0.801600\n')
            charge_file.write('    CHIE        N        -0.382100\n    CHIE        H         0.268100\n')
            charge_file.write('    CHIE        CA       -0.269900\n    CHIE        HA        0.165000\n')
            charge_file.write('    CHIE        CB       -0.106800\n    CHIE       HB2        0.062000\n')
            charge_file.write('    CHIE       HB3        0.062000\n    CHIE        CG        0.272400\n')
            charge_file.write('    CHIE       ND1       -0.551700\n    CHIE       CE1        0.155800\n')
            charge_file.write('    CHIE       HE1        0.144800\n    CHIE       NE2       -0.267000\n')
            charge_file.write('    CHIE       HE2        0.331900\n    CHIE       CD2       -0.258800\n')
            charge_file.write('    CHIE       HD2        0.195700\n    CHIE        C         0.791600\n')
            charge_file.write('    CHIE        O        -0.806500\n    CHIE       OXT       -0.806500\n')
            charge_file.write('    CHIP        N        -0.348100\n    CHIP        H         0.276400\n')
            charge_file.write('    CHIP        CA       -0.144500\n    CHIP        HA        0.111500\n')
            charge_file.write('    CHIP        CB       -0.080000\n    CHIP       HB2        0.086800\n')
            charge_file.write('    CHIP       HB3        0.086800\n    CHIP        CG        0.029800\n')
            charge_file.write('    CHIP       ND1       -0.150100\n    CHIP       HD1        0.388300\n')
            charge_file.write('    CHIP       CE1       -0.025100\n    CHIP       HE1        0.269400\n')
            charge_file.write('    CHIP       NE2       -0.168300\n    CHIP       HE2        0.391300\n')
            charge_file.write('    CHIP       CD2       -0.125600\n    CHIP       HD2        0.233600\n')
            charge_file.write('    CHIP        C         0.803200\n    CHIP        O        -0.817700\n')
            charge_file.write('    CHIP       OXT       -0.817700\n    CILE        N        -0.382100\n')
            charge_file.write('    CILE        H         0.268100\n    CILE        CA       -0.310000\n')
            charge_file.write('    CILE        HA        0.137500\n    CILE        CB        0.036300\n')
            charge_file.write('    CILE        HB        0.076600\n    CILE       CG2       -0.349800\n')
            charge_file.write('    CILE       HG21       0.102100\n    CILE       HG22       0.102100\n')
            charge_file.write('    CILE       HG23       0.102100\n    CILE       CG1       -0.032300\n')
            charge_file.write('    CILE       HG12       0.032100\n    CILE       HG13       0.032100\n')
            charge_file.write('    CILE       CD1       -0.069900\n    CILE       HD11       0.019600\n')
            charge_file.write('    CILE       HD12       0.019600\n    CILE       HD13       0.019600\n')
            charge_file.write('    CILE        C         0.834300\n    CILE        O        -0.819000\n')
            charge_file.write('    CILE       OXT       -0.819000\n    CLEU        N        -0.382100\n')
            charge_file.write('    CLEU        H         0.268100\n    CLEU        CA       -0.284700\n')
            charge_file.write('    CLEU        HA        0.134600\n    CLEU        CB       -0.246900\n')
            charge_file.write('    CLEU       HB2        0.097400\n    CLEU       HB3        0.097400\n')
            charge_file.write('    CLEU        CG        0.370600\n    CLEU        HG       -0.037400\n')
            charge_file.write('    CLEU       CD1       -0.416300\n    CLEU       HD11       0.103800\n')
            charge_file.write('    CLEU       HD12       0.103800\n    CLEU       HD13       0.103800\n')
            charge_file.write('    CLEU       CD2       -0.416300\n    CLEU       HD21       0.103800\n')
            charge_file.write('    CLEU       HD22       0.103800\n    CLEU       HD23       0.103800\n')
            charge_file.write('    CLEU        C         0.832600\n    CLEU        O        -0.819900\n')
            charge_file.write('    CLEU       OXT       -0.819900\n    CLYS        N        -0.348100\n')
            charge_file.write('    CLYS        H         0.276400\n    CLYS        CA       -0.290300\n')
            charge_file.write('    CLYS        HA        0.143800\n    CLYS        CB       -0.053800\n')
            charge_file.write('    CLYS       HB2        0.048200\n    CLYS       HB3        0.048200\n')
            charge_file.write('    CLYS        CG        0.022700\n    CLYS       HG2        0.013400\n')
            charge_file.write('    CLYS       HG3        0.013400\n    CLYS        CD       -0.039200\n')
            charge_file.write('    CLYS       HD2        0.061100\n    CLYS       HD3        0.061100\n')
            charge_file.write('    CLYS        CE       -0.017600\n    CLYS       HE2        0.112100\n')
            charge_file.write('    CLYS       HE3        0.112100\n    CLYS        NZ       -0.374100\n')
            charge_file.write('    CLYS       HZ1        0.337400\n    CLYS       HZ2        0.337400\n')
            charge_file.write('    CLYS       HZ3        0.337400\n    CLYS        C         0.848800\n')
            charge_file.write('    CLYS        O        -0.825200\n    CLYS       OXT       -0.825200\n')
            charge_file.write('    CMET        N        -0.382100\n    CMET        H         0.268100\n')
            charge_file.write('    CMET        CA       -0.259700\n    CMET        HA        0.127700\n')
            charge_file.write('    CMET        CB       -0.023600\n    CMET       HB2        0.048000\n')
            charge_file.write('    CMET       HB3        0.048000\n    CMET        CG        0.049200\n')
            charge_file.write('    CMET       HG2        0.031700\n    CMET       HG3        0.031700\n')
            charge_file.write('    CMET        SD       -0.269200\n    CMET        CE       -0.037600\n')
            charge_file.write('    CMET       HE1        0.062500\n    CMET       HE2        0.062500\n')
            charge_file.write('    CMET       HE3        0.062500\n    CMET        C         0.801300\n')
            charge_file.write('    CMET        O        -0.810500\n    CMET       OXT       -0.810500\n')
            charge_file.write('    CPHE        N        -0.382100\n    CPHE        H         0.268100\n')
            charge_file.write('    CPHE        CA       -0.182500\n    CPHE        HA        0.109800\n')
            charge_file.write('    CPHE        CB       -0.095900\n    CPHE       HB2        0.044300\n')
            charge_file.write('    CPHE       HB3        0.044300\n    CPHE        CG        0.055200\n')
            charge_file.write('    CPHE       CD1       -0.130000\n    CPHE       HD1        0.140800\n')
            charge_file.write('    CPHE       CE1       -0.184700\n    CPHE       HE1        0.146100\n')
            charge_file.write('    CPHE        CZ       -0.094400\n    CPHE        HZ        0.128000\n')
            charge_file.write('    CPHE       CE2       -0.184700\n    CPHE       HE2        0.146100\n')
            charge_file.write('    CPHE       CD2       -0.130000\n    CPHE       HD2        0.140800\n')
            charge_file.write('    CPHE        C         0.766000\n    CPHE        O        -0.802600\n')
            charge_file.write('    CPHE       OXT       -0.802600\n    CPRO        N        -0.280200\n')
            charge_file.write('    CPRO        CD        0.043400\n    CPRO       HD2        0.033100\n')
            charge_file.write('    CPRO       HD3        0.033100\n    CPRO        CG        0.046600\n')
            charge_file.write('    CPRO       HG2        0.017200\n    CPRO       HG3        0.017200\n')
            charge_file.write('    CPRO        CB       -0.054300\n    CPRO       HB2        0.038100\n')
            charge_file.write('    CPRO       HB3        0.038100\n    CPRO        CA       -0.133600\n')
            charge_file.write('    CPRO        HA        0.077600\n    CPRO        C         0.663100\n')
            charge_file.write('    CPRO        O        -0.769700\n    CPRO       OXT       -0.769700\n')
            charge_file.write('    CSER        N        -0.382100\n    CSER        H         0.268100\n')
            charge_file.write('    CSER        CA       -0.272200\n    CSER        HA        0.130400\n')
            charge_file.write('    CSER        CB        0.112300\n    CSER       HB2        0.081300\n')
            charge_file.write('    CSER       HB3        0.081300\n    CSER        OG       -0.651400\n')
            charge_file.write('    CSER        HG        0.447400\n    CSER        C         0.811300\n')
            charge_file.write('    CSER        O        -0.813200\n    CSER       OXT       -0.813200\n')
            charge_file.write('    CTHR        N        -0.382100\n    CTHR        H         0.268100\n')
            charge_file.write('    CTHR        CA       -0.242000\n    CTHR        HA        0.120700\n')
            charge_file.write('    CTHR        CB        0.302500\n    CTHR        HB        0.007800\n')
            charge_file.write('    CTHR       CG2       -0.185300\n    CTHR       HG21       0.058600\n')
            charge_file.write('    CTHR       HG22       0.058600\n    CTHR       HG23       0.058600\n')
            charge_file.write('    CTHR       OG1       -0.649600\n    CTHR       HG1        0.411900\n')
            charge_file.write('    CTHR        C         0.781000\n    CTHR        O        -0.804400\n')
            charge_file.write('    CTHR       OXT       -0.804400\n    CTRP        N        -0.382100\n')
            charge_file.write('    CTRP        H         0.268100\n    CTRP        CA       -0.208400\n')
            charge_file.write('    CTRP        HA        0.127200\n    CTRP        CB       -0.074200\n')
            charge_file.write('    CTRP       HB2        0.049700\n    CTRP       HB3        0.049700\n')
            charge_file.write('    CTRP        CG       -0.079600\n    CTRP       CD1       -0.180800\n')
            charge_file.write('    CTRP       HD1        0.204300\n    CTRP       NE1       -0.331600\n')
            charge_file.write('    CTRP       HE1        0.341300\n    CTRP       CE2        0.122200\n')
            charge_file.write('    CTRP       CZ2       -0.259400\n    CTRP       HZ2        0.156700\n')
            charge_file.write('    CTRP       CH2       -0.102000\n    CTRP       HH2        0.140100\n')
            charge_file.write('    CTRP       CZ3       -0.228700\n    CTRP       HZ3        0.150700\n')
            charge_file.write('    CTRP       CE3       -0.183700\n    CTRP       HE3        0.149100\n')
            charge_file.write('    CTRP       CD2        0.107800\n    CTRP        C         0.765800\n')
            charge_file.write('    CTRP        O        -0.801100\n    CTRP       OXT       -0.801100\n')
            charge_file.write('    CTYR        N        -0.382100\n    CTYR        H         0.268100\n')
            charge_file.write('    CTYR        CA       -0.201500\n    CTYR        HA        0.109200\n')
            charge_file.write('    CTYR        CB       -0.075200\n    CTYR       HB2        0.049000\n')
            charge_file.write('    CTYR       HB3        0.049000\n    CTYR        CG        0.024300\n')
            charge_file.write('    CTYR       CD1       -0.192200\n    CTYR       HD1        0.178000\n')
            charge_file.write('    CTYR       CE1       -0.245800\n    CTYR       HE1        0.167300\n')
            charge_file.write('    CTYR        CZ        0.339500\n    CTYR        OH       -0.564300\n')
            charge_file.write('    CTYR        HH        0.401700\n    CTYR       CE2       -0.245800\n')
            charge_file.write('    CTYR       HE2        0.167300\n    CTYR       CD2       -0.192200\n')
            charge_file.write('    CTYR       HD2        0.178000\n    CTYR        C         0.781700\n')
            charge_file.write('    CTYR        O        -0.807000\n    CTYR       OXT       -0.807000\n')
            charge_file.write('    CVAL        N        -0.382100\n    CVAL        H         0.268100\n')
            charge_file.write('    CVAL        CA       -0.343800\n    CVAL        HA        0.143800\n')
            charge_file.write('    CVAL        CB        0.194000\n    CVAL        HB        0.030800\n')
            charge_file.write('    CVAL       CG1       -0.306400\n    CVAL       HG11       0.083600\n')
            charge_file.write('    CVAL       HG12       0.083600\n    CVAL       HG13       0.083600\n')
            charge_file.write('    CVAL       CG2       -0.306400\n    CVAL       HG21       0.083600\n')
            charge_file.write('    CVAL       HG22       0.083600\n    CVAL       HG23       0.083600\n')
            charge_file.write('    CVAL        C         0.835000\n    CVAL        O        -0.817300\n')
            charge_file.write('    CVAL       OXT       -0.817300\n    NHE         N        -0.463000\n')
            charge_file.write('    NHE        HN1        0.231500\n    NHE        HN2        0.231500\n')
            charge_file.write('    NME         N        -0.415700\n    NME         H         0.271900\n')
            charge_file.write('    NME        CH3       -0.149000\n    NME        HH31       0.097600\n')
            charge_file.write('    NME        HH32       0.097600\n    NME        HH33       0.097600\n')
            charge_file.write('    ACE        HH31       0.112300\n    ACE        CH3       -0.366200\n')
            charge_file.write('    ACE        HH32       0.112300\n    ACE        HH33       0.112300\n')
            charge_file.write('    ACE         C         0.597200\n    ACE         O        -0.567900\n')
            charge_file.write('    NALA        N         0.141400\n    NALA        H1        0.199700\n')
            charge_file.write('    NALA        H2        0.199700\n    NALA        H3        0.199700\n')
            charge_file.write('    NALA        CA        0.096200\n    NALA        HA        0.088900\n')
            charge_file.write('    NALA        CB       -0.059700\n    NALA       HB1        0.030000\n')
            charge_file.write('    NALA       HB2        0.030000\n    NALA       HB3        0.030000\n')
            charge_file.write('    NALA        C         0.616300\n    NALA        O        -0.572200\n')
            charge_file.write('    NARG        N         0.130500\n    NARG        H1        0.208300\n')
            charge_file.write('    NARG        H2        0.208300\n    NARG        H3        0.208300\n')
            charge_file.write('    NARG        CA       -0.022300\n    NARG        HA        0.124200\n')
            charge_file.write('    NARG        CB        0.011800\n    NARG       HB2        0.022600\n')
            charge_file.write('    NARG       HB3        0.022600\n    NARG        CG        0.023600\n')
            charge_file.write('    NARG       HG2        0.030900\n    NARG       HG3        0.030900\n')
            charge_file.write('    NARG        CD        0.093500\n    NARG       HD2        0.052700\n')
            charge_file.write('    NARG       HD3        0.052700\n    NARG        NE       -0.565000\n')
            charge_file.write('    NARG        HE        0.359200\n    NARG        CZ        0.828100\n')
            charge_file.write('    NARG       NH1       -0.869300\n    NARG       HH11       0.449400\n')
            charge_file.write('    NARG       HH12       0.449400\n    NARG       NH2       -0.869300\n')
            charge_file.write('    NARG       HH21       0.449400\n    NARG       HH22       0.449400\n')
            charge_file.write('    NARG        C         0.721400\n    NARG        O        -0.601300\n')
            charge_file.write('    NASN        N         0.180100\n    NASN        H1        0.192100\n')
            charge_file.write('    NASN        H2        0.192100\n    NASN        H3        0.192100\n')
            charge_file.write('    NASN        CA        0.036800\n    NASN        HA        0.123100\n')
            charge_file.write('    NASN        CB       -0.028300\n    NASN       HB2        0.051500\n')
            charge_file.write('    NASN       HB3        0.051500\n    NASN        CG        0.583300\n')
            charge_file.write('    NASN       OD1       -0.574400\n    NASN       ND2       -0.863400\n')
            charge_file.write('    NASN       HD21       0.409700\n    NASN       HD22       0.409700\n')
            charge_file.write('    NASN        C         0.616300\n    NASN        O        -0.572200\n')
            charge_file.write('    NASP        N         0.078200\n    NASP        H1        0.220000\n')
            charge_file.write('    NASP        H2        0.220000\n    NASP        H3        0.220000\n')
            charge_file.write('    NASP        CA        0.029200\n    NASP        HA        0.114100\n')
            charge_file.write('    NASP        CB       -0.023500\n    NASP       HB2       -0.016900\n')
            charge_file.write('    NASP       HB3       -0.016900\n    NASP        CG        0.819400\n')
            charge_file.write('    NASP       OD1       -0.808400\n    NASP       OD2       -0.808400\n')
            charge_file.write('    NASP        C         0.562100\n    NASP        O        -0.588900\n')
            charge_file.write('    NCYS        N         0.132500\n    NCYS        H1        0.202300\n')
            charge_file.write('    NCYS        H2        0.202300\n    NCYS        H3        0.202300\n')
            charge_file.write('    NCYS        CA        0.092700\n    NCYS        HA        0.141100\n')
            charge_file.write('    NCYS        CB       -0.119500\n    NCYS       HB2        0.118800\n')
            charge_file.write('    NCYS       HB3        0.118800\n    NCYS        SG       -0.329800\n')
            charge_file.write('    NCYS        HG        0.197500\n    NCYS        C         0.612300\n')
            charge_file.write('    NCYS        O        -0.571300\n    NCYX        N         0.206900\n')
            charge_file.write('    NCYX        H1        0.181500\n    NCYX        H2        0.181500\n')
            charge_file.write('    NCYX        H3        0.181500\n    NCYX        CA        0.105500\n')
            charge_file.write('    NCYX        HA        0.092200\n    NCYX        CB       -0.027700\n')
            charge_file.write('    NCYX       HB2        0.068000\n    NCYX       HB3        0.068000\n')
            charge_file.write('    NCYX        SG       -0.098400\n    NCYX        C         0.612300\n')
            charge_file.write('    NCYX        O        -0.571300\n    NGLN        N         0.149300\n')
            charge_file.write('    NGLN        H1        0.199600\n    NGLN        H2        0.199600\n')
            charge_file.write('    NGLN        H3        0.199600\n    NGLN        CA        0.053600\n')
            charge_file.write('    NGLN        HA        0.101500\n    NGLN        CB        0.065100\n')
            charge_file.write('    NGLN       HB2        0.005000\n    NGLN       HB3        0.005000\n')
            charge_file.write('    NGLN        CG       -0.090300\n    NGLN       HG2        0.033100\n')
            charge_file.write('    NGLN       HG3        0.033100\n    NGLN        CD        0.735400\n')
            charge_file.write('    NGLN       OE1       -0.613300\n    NGLN       NE2       -1.003100\n')
            charge_file.write('    NGLN       HE21       0.442900\n    NGLN       HE22       0.442900\n')
            charge_file.write('    NGLN        C         0.612300\n    NGLN        O        -0.571300\n')
            charge_file.write('    NGLU        N         0.001700\n    NGLU        H1        0.239100\n')
            charge_file.write('    NGLU        H2        0.239100\n    NGLU        H3        0.239100\n')
            charge_file.write('    NGLU        CA        0.058800\n    NGLU        HA        0.120200\n')
            charge_file.write('    NGLU        CB        0.090900\n    NGLU       HB2       -0.023200\n')
            charge_file.write('    NGLU       HB3       -0.023200\n    NGLU        CG       -0.023600\n')
            charge_file.write('    NGLU       HG2       -0.031500\n    NGLU       HG3       -0.031500\n')
            charge_file.write('    NGLU        CD        0.808700\n    NGLU       OE1       -0.818900\n')
            charge_file.write('    NGLU       OE2       -0.818900\n    NGLU        C         0.562100\n')
            charge_file.write('    NGLU        O        -0.588900\n    NGLY        N         0.294300\n')
            charge_file.write('    NGLY        H1        0.164200\n    NGLY        H2        0.164200\n')
            charge_file.write('    NGLY        H3        0.164200\n    NGLY        CA       -0.010000\n')
            charge_file.write('    NGLY       HA2        0.089500\n    NGLY       HA3        0.089500\n')
            charge_file.write('    NGLY        C         0.616300\n    NGLY        O        -0.572200\n')
            charge_file.write('    NHID        N         0.154200\n    NHID        H1        0.196300\n')
            charge_file.write('    NHID        H2        0.196300\n    NHID        H3        0.196300\n')
            charge_file.write('    NHID        CA        0.096400\n    NHID        HA        0.095800\n')
            charge_file.write('    NHID        CB        0.025900\n    NHID       HB2        0.020900\n')
            charge_file.write('    NHID       HB3        0.020900\n    NHID        CG       -0.039900\n')
            charge_file.write('    NHID       ND1       -0.381900\n    NHID       HD1        0.363200\n')
            charge_file.write('    NHID       CE1        0.212700\n    NHID       HE1        0.138500\n')
            charge_file.write('    NHID       NE2       -0.571100\n    NHID       CD2        0.104600\n')
            charge_file.write('    NHID       HD2        0.129900\n    NHID        C         0.612300\n')
            charge_file.write('    NHID        O        -0.571300\n    NHIE        N         0.147200\n')
            charge_file.write('    NHIE        H1        0.201600\n    NHIE        H2        0.201600\n')
            charge_file.write('    NHIE        H3        0.201600\n    NHIE        CA        0.023600\n')
            charge_file.write('    NHIE        HA        0.138000\n    NHIE        CB        0.048900\n')
            charge_file.write('    NHIE       HB2        0.022300\n    NHIE       HB3        0.022300\n')
            charge_file.write('    NHIE        CG        0.174000\n    NHIE       ND1       -0.557900\n')
            charge_file.write('    NHIE       CE1        0.180400\n    NHIE       HE1        0.139700\n')
            charge_file.write('    NHIE       NE2       -0.278100\n    NHIE       HE2        0.332400\n')
            charge_file.write('    NHIE       CD2       -0.234900\n    NHIE       HD2        0.196300\n')
            charge_file.write('    NHIE        C         0.612300\n    NHIE        O        -0.571300\n')
            charge_file.write('    NHIP        N         0.256000\n    NHIP        H1        0.170400\n')
            charge_file.write('    NHIP        H2        0.170400\n    NHIP        H3        0.170400\n')
            charge_file.write('    NHIP        CA        0.058100\n    NHIP        HA        0.104700\n')
            charge_file.write('    NHIP        CB        0.048400\n    NHIP       HB2        0.053100\n')
            charge_file.write('    NHIP       HB3        0.053100\n    NHIP        CG       -0.023600\n')
            charge_file.write('    NHIP       ND1       -0.151000\n    NHIP       HD1        0.382100\n')
            charge_file.write('    NHIP       CE1       -0.001100\n    NHIP       HE1        0.264500\n')
            charge_file.write('    NHIP       NE2       -0.173900\n    NHIP       HE2        0.392100\n')
            charge_file.write('    NHIP       CD2       -0.143300\n    NHIP       HD2        0.249500\n')
            charge_file.write('    NHIP        C         0.721400\n    NHIP        O        -0.601300\n')
            charge_file.write('    NILE        N         0.031100\n    NILE        H1        0.232900\n')
            charge_file.write('    NILE        H2        0.232900\n    NILE        H3        0.232900\n')
            charge_file.write('    NILE        CA        0.025700\n    NILE        HA        0.103100\n')
            charge_file.write('    NILE        CB        0.188500\n    NILE        HB        0.021300\n')
            charge_file.write('    NILE       CG2       -0.372000\n    NILE       HG21       0.094700\n')
            charge_file.write('    NILE       HG22       0.094700\n    NILE       HG23       0.094700\n')
            charge_file.write('    NILE       CG1       -0.038700\n    NILE       HG12       0.020100\n')
            charge_file.write('    NILE       HG13       0.020100\n    NILE       CD1       -0.090800\n')
            charge_file.write('    NILE       HD11       0.022600\n    NILE       HD12       0.022600\n')
            charge_file.write('    NILE       HD13       0.022600\n    NILE        C         0.612300\n')
            charge_file.write('    NILE        O        -0.571300\n    NLEU        N         0.101000\n')
            charge_file.write('    NLEU        H1        0.214800\n    NLEU        H2        0.214800\n')
            charge_file.write('    NLEU        H3        0.214800\n    NLEU        CA        0.010400\n')
            charge_file.write('    NLEU        HA        0.105300\n    NLEU        CB       -0.024400\n')
            charge_file.write('    NLEU       HB2        0.025600\n    NLEU       HB3        0.025600\n')
            charge_file.write('    NLEU        CG        0.342100\n    NLEU        HG       -0.038000\n')
            charge_file.write('    NLEU       CD1       -0.410600\n    NLEU       HD11       0.098000\n')
            charge_file.write('    NLEU       HD12       0.098000\n    NLEU       HD13       0.098000\n')
            charge_file.write('    NLEU       CD2       -0.410400\n    NLEU       HD21       0.098000\n')
            charge_file.write('    NLEU       HD22       0.098000\n    NLEU       HD23       0.098000\n')
            charge_file.write('    NLEU        C         0.612300\n    NLEU        O        -0.571300\n')
            charge_file.write('    NLYS        N         0.096600\n    NLYS        H1        0.216500\n')
            charge_file.write('    NLYS        H2        0.216500\n    NLYS        H3        0.216500\n')
            charge_file.write('    NLYS        CA       -0.001500\n    NLYS        HA        0.118000\n')
            charge_file.write('    NLYS        CB        0.021200\n    NLYS       HB2        0.028300\n')
            charge_file.write('    NLYS       HB3        0.028300\n    NLYS        CG       -0.004800\n')
            charge_file.write('    NLYS       HG2        0.012100\n    NLYS       HG3        0.012100\n')
            charge_file.write('    NLYS        CD       -0.060800\n    NLYS       HD2        0.063300\n')
            charge_file.write('    NLYS       HD3        0.063300\n    NLYS        CE       -0.018100\n')
            charge_file.write('    NLYS       HE2        0.117100\n    NLYS       HE3        0.117100\n')
            charge_file.write('    NLYS        NZ       -0.376400\n    NLYS       HZ1        0.338200\n')
            charge_file.write('    NLYS       HZ2        0.338200\n    NLYS       HZ3        0.338200\n')
            charge_file.write('    NLYS        C         0.721400\n    NLYS        O        -0.601300\n')
            charge_file.write('    NMET        N         0.159200\n    NMET        H1        0.198400\n')
            charge_file.write('    NMET        H2        0.198400\n    NMET        H3        0.198400\n')
            charge_file.write('    NMET        CA        0.022100\n    NMET        HA        0.111600\n')
            charge_file.write('    NMET        CB        0.086500\n    NMET       HB2        0.012500\n')
            charge_file.write('    NMET       HB3        0.012500\n    NMET        CG        0.033400\n')
            charge_file.write('    NMET       HG2        0.029200\n    NMET       HG3        0.029200\n')
            charge_file.write('    NMET        SD       -0.277400\n    NMET        CE       -0.034100\n')
            charge_file.write('    NMET       HE1        0.059700\n    NMET       HE2        0.059700\n')
            charge_file.write('    NMET       HE3        0.059700\n    NMET        C         0.612300\n')
            charge_file.write('    NMET        O        -0.571300\n    NPHE        N         0.173700\n')
            charge_file.write('    NPHE        H1        0.192100\n    NPHE        H2        0.192100\n')
            charge_file.write('    NPHE        H3        0.192100\n    NPHE        CA        0.073300\n')
            charge_file.write('    NPHE        HA        0.104100\n    NPHE        CB        0.033000\n')
            charge_file.write('    NPHE       HB2        0.010400\n    NPHE       HB3        0.010400\n')
            charge_file.write('    NPHE        CG        0.003100\n    NPHE       CD1       -0.139200\n')
            charge_file.write('    NPHE       HD1        0.137400\n    NPHE       CE1       -0.160200\n')
            charge_file.write('    NPHE       HE1        0.143300\n    NPHE        CZ       -0.120800\n')
            charge_file.write('    NPHE        HZ        0.132900\n    NPHE       CE2       -0.160300\n')
            charge_file.write('    NPHE       HE2        0.143300\n    NPHE       CD2       -0.139100\n')
            charge_file.write('    NPHE       HD2        0.137400\n    NPHE        C         0.612300\n')
            charge_file.write('    NPHE        O        -0.571300\n    NPRO        N        -0.202000\n')
            charge_file.write('    NPRO        H2        0.312000\n    NPRO        H3        0.312000\n')
            charge_file.write('    NPRO        CD       -0.012000\n    NPRO       HD2        0.100000\n')
            charge_file.write('    NPRO       HD3        0.100000\n    NPRO        CG       -0.121000\n')
            charge_file.write('    NPRO       HG2        0.100000\n    NPRO       HG3        0.100000\n')
            charge_file.write('    NPRO        CB       -0.115000\n    NPRO       HB2        0.100000\n')
            charge_file.write('    NPRO       HB3        0.100000\n    NPRO        CA        0.100000\n')
            charge_file.write('    NPRO        HA        0.100000\n    NPRO        C         0.526000\n')
            charge_file.write('    NPRO        O        -0.500000\n    NSER        N         0.184900\n')
            charge_file.write('    NSER        H1        0.189800\n    NSER        H2        0.189800\n')
            charge_file.write('    NSER        H3        0.189800\n    NSER        CA        0.056700\n')
            charge_file.write('    NSER        HA        0.078200\n    NSER        CB        0.259600\n')
            charge_file.write('    NSER       HB2        0.027300\n    NSER       HB3        0.027300\n')
            charge_file.write('    NSER        OG       -0.671400\n    NSER        HG        0.423900\n')
            charge_file.write('    NSER        C         0.616300\n    NSER        O        -0.572200\n')
            charge_file.write('    NTHR        N         0.181200\n    NTHR        H1        0.193400\n')
            charge_file.write('    NTHR        H2        0.193400\n    NTHR        H3        0.193400\n')
            charge_file.write('    NTHR        CA        0.003400\n    NTHR        HA        0.108700\n')
            charge_file.write('    NTHR        CB        0.451400\n    NTHR        HB       -0.032300\n')
            charge_file.write('    NTHR       CG2       -0.255400\n    NTHR       HG21       0.062700\n')
            charge_file.write('    NTHR       HG22       0.062700\n    NTHR       HG23       0.062700\n')
            charge_file.write('    NTHR       OG1       -0.676400\n    NTHR       HG1        0.407000\n')
            charge_file.write('    NTHR        C         0.616300\n    NTHR        O        -0.572200\n')
            charge_file.write('    NTRP        N         0.191300\n    NTRP        H1        0.188800\n')
            charge_file.write('    NTRP        H2        0.188800\n    NTRP        H3        0.188800\n')
            charge_file.write('    NTRP        CA        0.042100\n    NTRP        HA        0.116200\n')
            charge_file.write('    NTRP        CB        0.054300\n    NTRP       HB2        0.022200\n')
            charge_file.write('    NTRP       HB3        0.022200\n    NTRP        CG       -0.165400\n')
            charge_file.write('    NTRP       CD1       -0.178800\n    NTRP       HD1        0.219500\n')
            charge_file.write('    NTRP       NE1       -0.344400\n    NTRP       HE1        0.341200\n')
            charge_file.write('    NTRP       CE2        0.157500\n    NTRP       CZ2       -0.271000\n')
            charge_file.write('    NTRP       HZ2        0.158900\n    NTRP       CH2       -0.108000\n')
            charge_file.write('    NTRP       HH2        0.141100\n    NTRP       CZ3       -0.203400\n')
            charge_file.write('    NTRP       HZ3        0.145800\n    NTRP       CE3       -0.226500\n')
            charge_file.write('    NTRP       HE3        0.164600\n    NTRP       CD2        0.113200\n')
            charge_file.write('    NTRP        C         0.612300\n    NTRP        O        -0.571300\n')
            charge_file.write('    NTYR        N         0.194000\n    NTYR        H1        0.187300\n')
            charge_file.write('    NTYR        H2        0.187300\n    NTYR        H3        0.187300\n')
            charge_file.write('    NTYR        CA        0.057000\n    NTYR        HA        0.098300\n')
            charge_file.write('    NTYR        CB        0.065900\n    NTYR       HB2        0.010200\n')
            charge_file.write('    NTYR       HB3        0.010200\n    NTYR        CG       -0.020500\n')
            charge_file.write('    NTYR       CD1       -0.200200\n    NTYR       HD1        0.172000\n')
            charge_file.write('    NTYR       CE1       -0.223900\n    NTYR       HE1        0.165000\n')
            charge_file.write('    NTYR        CZ        0.313900\n    NTYR        OH       -0.557800\n')
            charge_file.write('    NTYR        HH        0.400100\n    NTYR       CE2       -0.223900\n')
            charge_file.write('    NTYR       HE2        0.165000\n    NTYR       CD2       -0.200200\n')
            charge_file.write('    NTYR       HD2        0.172000\n    NTYR        C         0.612300\n')
            charge_file.write('    NTYR        O        -0.571300\n    NVAL        N         0.057700\n')
            charge_file.write('    NVAL        H1        0.227200\n    NVAL        H2        0.227200\n')
            charge_file.write('    NVAL        H3        0.227200\n    NVAL        CA       -0.005400\n')
            charge_file.write('    NVAL        HA        0.109300\n    NVAL        CB        0.319600\n')
            charge_file.write('    NVAL        HB       -0.022100\n    NVAL       CG1       -0.312900\n')
            charge_file.write('    NVAL       HG11       0.073500\n    NVAL       HG12       0.073500\n')
            charge_file.write('    NVAL       HG13       0.073500\n    NVAL       CG2       -0.312900\n')
            charge_file.write('    NVAL       HG21       0.073500\n    NVAL       HG22       0.073500\n')
            charge_file.write('    NVAL       HG23       0.073500\n    NVAL        C         0.616300\n')
            charge_file.write('    NVAL        O        -0.572200\n;%39s\n' %('='*39))
        with open(self.temp_illustration, 'a') as tmp_info:
            tmp_info.write('# The parameters of residue charge information under force field(MMFF94).\n\t%s\n' %'mmff94.dat')


    def ligand_paras(self):
        self.ligand_data()
        sline = [_m.rstrip() for _m in open('ligand.database')]
        a0 = []; a1 = []; a2 = []
        for line in sline:
            if line[:1] != ';':
                a0.append(line.split()[0].strip()+line.split()[1].strip())
                a1.append(float(line.split()[2].strip()))
                a2.append(float(line.split()[3].strip()))
        return a0, a1, a2
